// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_msgs:msg/TrafficConditionSubCauseCode.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_MSGS__MSG__DETAIL__TRAFFIC_CONDITION_SUB_CAUSE_CODE__STRUCT_H_
#define ETSI_ITS_DENM_MSGS__MSG__DETAIL__TRAFFIC_CONDITION_SUB_CAUSE_CODE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_denm_msgs__msg__TrafficConditionSubCauseCode__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_denm_msgs__msg__TrafficConditionSubCauseCode__MAX = 255
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_denm_msgs__msg__TrafficConditionSubCauseCode__UNAVAILABLE = 0
};

/// Constant 'INCREASED_VOLUME_OF_TRAFFIC'.
enum
{
  etsi_its_denm_msgs__msg__TrafficConditionSubCauseCode__INCREASED_VOLUME_OF_TRAFFIC = 1
};

/// Constant 'TRAFFIC_JAM_SLOWLY_INCREASING'.
enum
{
  etsi_its_denm_msgs__msg__TrafficConditionSubCauseCode__TRAFFIC_JAM_SLOWLY_INCREASING = 2
};

/// Constant 'TRAFFIC_JAM_INCREASING'.
enum
{
  etsi_its_denm_msgs__msg__TrafficConditionSubCauseCode__TRAFFIC_JAM_INCREASING = 3
};

/// Constant 'TRAFFIC_JAM_STRONGLY_INCREASING'.
enum
{
  etsi_its_denm_msgs__msg__TrafficConditionSubCauseCode__TRAFFIC_JAM_STRONGLY_INCREASING = 4
};

/// Constant 'TRAFFIC_STATIONARY'.
enum
{
  etsi_its_denm_msgs__msg__TrafficConditionSubCauseCode__TRAFFIC_STATIONARY = 5
};

/// Constant 'TRAFFIC_JAM_SLIGHTLY_DECREASING'.
enum
{
  etsi_its_denm_msgs__msg__TrafficConditionSubCauseCode__TRAFFIC_JAM_SLIGHTLY_DECREASING = 6
};

/// Constant 'TRAFFIC_JAM_DECREASING'.
enum
{
  etsi_its_denm_msgs__msg__TrafficConditionSubCauseCode__TRAFFIC_JAM_DECREASING = 7
};

/// Constant 'TRAFFIC_JAM_STRONGLY_DECREASING'.
enum
{
  etsi_its_denm_msgs__msg__TrafficConditionSubCauseCode__TRAFFIC_JAM_STRONGLY_DECREASING = 8
};

/// Struct defined in msg/TrafficConditionSubCauseCode in the package etsi_its_denm_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_msgs__msg__TrafficConditionSubCauseCode
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_en302637_3/DENM-PDU-Descriptions.asn
  ///   asn1/raw/denm_en302637_3/cdd/ITS-Container.asn
  ///   -t
  ///   denm
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// TrafficConditionSubCauseCode ::= INTEGER {unavailable(0), increasedVolumeOfTraffic(1), trafficJamSlowlyIncreasing(2), trafficJamIncreasing(3), trafficJamStronglyIncreasing(4), trafficStationary(5), trafficJamSlightlyDecreasing(6), trafficJamDecreasing(7), trafficJamStronglyDecreasing(8)} (0..255)
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_denm_msgs__msg__TrafficConditionSubCauseCode;

// Struct for a sequence of etsi_its_denm_msgs__msg__TrafficConditionSubCauseCode.
typedef struct etsi_its_denm_msgs__msg__TrafficConditionSubCauseCode__Sequence
{
  etsi_its_denm_msgs__msg__TrafficConditionSubCauseCode * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_msgs__msg__TrafficConditionSubCauseCode__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_MSGS__MSG__DETAIL__TRAFFIC_CONDITION_SUB_CAUSE_CODE__STRUCT_H_
