// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_denm_msgs:msg/DENM.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_MSGS__MSG__DETAIL__DENM__TRAITS_HPP_
#define ETSI_ITS_DENM_MSGS__MSG__DETAIL__DENM__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_denm_msgs/msg/detail/denm__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "etsi_its_denm_msgs/msg/detail/its_pdu_header__traits.hpp"
// Member 'denm'
#include "etsi_its_denm_msgs/msg/detail/decentralized_environmental_notification_message__traits.hpp"

namespace etsi_its_denm_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const DENM & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: denm
  {
    out << "denm: ";
    to_flow_style_yaml(msg.denm, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DENM & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: denm
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "denm:\n";
    to_block_style_yaml(msg.denm, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DENM & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_denm_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_denm_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_denm_msgs::msg::DENM & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_denm_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_denm_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_denm_msgs::msg::DENM & msg)
{
  return etsi_its_denm_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_denm_msgs::msg::DENM>()
{
  return "etsi_its_denm_msgs::msg::DENM";
}

template<>
inline const char * name<etsi_its_denm_msgs::msg::DENM>()
{
  return "etsi_its_denm_msgs/msg/DENM";
}

template<>
struct has_fixed_size<etsi_its_denm_msgs::msg::DENM>
  : std::integral_constant<bool, has_fixed_size<etsi_its_denm_msgs::msg::DecentralizedEnvironmentalNotificationMessage>::value && has_fixed_size<etsi_its_denm_msgs::msg::ItsPduHeader>::value> {};

template<>
struct has_bounded_size<etsi_its_denm_msgs::msg::DENM>
  : std::integral_constant<bool, has_bounded_size<etsi_its_denm_msgs::msg::DecentralizedEnvironmentalNotificationMessage>::value && has_bounded_size<etsi_its_denm_msgs::msg::ItsPduHeader>::value> {};

template<>
struct is_message<etsi_its_denm_msgs::msg::DENM>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_DENM_MSGS__MSG__DETAIL__DENM__TRAITS_HPP_
